class KeiriController < ApplicationController

  def index
  end
  
  # ȖڂɑΉ関ȖڂԂ
  def get_payable_code(title)
    title.account_code <= 799 ? 305 : 321
  end
  private :get_payable_code
  
  def get_yen_amount(entry_day, amount, currency)
    cr = CurrencyRate.find :first,
                 :select => 'MAX(date) as date',
                 :conditions => ['currency_id = ? AND date < ?', currency.id, entry_day]
    raise if !cr
    cr = CurrencyRate.find :first, :conditions => ['currency_id = ? AND date = ?',
                                              currency.id, cr.date]
    return (Float(amount) * cr.rate / 10 ** currency.exponent).to_i
  end
  private :get_yen_amount
  
  # dmF
  def export
    invoices = Invoice.find :all, :conditions => 'state < 20'
    fixed_day = CompanySetting.find(:first).fixed_day
    @entries = []
    invoices.each {|inv|
      entry_day = [inv.buy_day, fixed_day + 1].max
      
      inv.invoice_details.each {|detail|
        line = {
          :entry_day => entry_day,
          :entry_no => 10000 + inv.id,  # TODO:ߑłBfixme
          :account_title => detail.account_title,
          :division => detail.division,
          :payable_code => get_payable_code(detail.account_title),
          :bank_account => (inv.bank_account ? inv.bank_account.id : inv.partner.zaimu_id),
          :amount => get_yen_amount(entry_day, detail.amount, inv.currency),
          :vat => (detail.account_title.vat_code != 0 ? detail.account_title.vat_code : 10),
          :due_day => inv.due_day
        }
        if inv.currency.code == "JPY"
          line[:remarks] = [detail.division.name, inv.partner.name,
                    "#{detail.remarks} #{inv.buy_day.mon}/#{inv.buy_day.day}"].join('/')
        else
          line[:remarks] = [detail.division.name, inv.partner.name,
          "#{detail.remarks} #{format_amount(detail.amount, inv.currency.exponent)}#{inv.currency.code} #{inv.buy_day.mon}/#{inv.buy_day.day}"].join('/')
        end
        @entries << line
      }
    }
    session[:entries] = [invoices, @entries]   # TODO: ̐lgƕsBviewstateɂׂB
  end
  
  # ۂ̏o
  def export2
    invoices, @entries = session[:entries]

    headers["Content-Type"] = "application/vnd.ms-excel; charset=UTF-8"
    headers["Content-Disposition"] = "attachment;\n  filename*=iso-2022-jp'ja'" +
                                     NKF.nkf("-m0 -j -W", "purchase.csv")
    render :action => 'export2', :layout => false

    # stateXV
    invoices.each {|inv|
      #inv.state = 20
      inv.save!
    }
  end
end
