class InvoiceDetail < ActiveRecord::Base
  belongs_to :invoice
  belongs_to :account_title
  belongs_to :division
  
  VAT_NAMES = {0 => "(科目に従う)", 10 => "税込み", 30 => "非課税", 40 => "不課税"}
  
  def self.vat_ary
    a = VAT_NAMES.to_a.sort {|x, y| x[0] <=> y[0]}
    a.collect {|k, v| [v, k]}
  end
end
